HDU 1081 To The Max 暴力模拟O(n^4) dp优化O(n^3)

原题: http://acm.hdu.edu.cn/showproblem.php?pid=1081

题目大意:

求给定边长的正方形选一个矩形,使它包含的所有元素的值最大。

大家都知道(a+b)^2的展开式,这里的优化就是用了这个原理来做的优化,我们的dp值是我们前i行j列的矩形区域的值。

任意矩形区域的值通过该展开式也能求解,所以我们可以暴力枚举每种以左上角(k,l)到右下角(i,j)的情况。

对于这个题边长是100,4层循环是10^8,因为循环并跑不了这么多,刚好也能卡过去。

代码如下:

#include <iostream>
#include"cstdio"
#include"string.h"
using namespace std;

const int N = 105;
int a[N][N];
int dp[N][N];
int ans[N][N];
int n,m;

int main()
{
    //freopen("in.txt","r",stdin);
    while(scanf("%d",&n)!=EOF)
    {
    //初始化
        memset(a,0,sizeof(a));
        memset(dp,0,sizeof(dp));
        memset(ans,0,sizeof(ans));
        for(int i=0; i<=n; i++)
            for(int j=0; j<=n; j++)
                ans[i][j]=-12345678;
    //读图
        for(int i=1; i<=n; i++)
            for(int j=1; j<=n; j++)
                scanf("%d",&a[i][j]);
    //优化
        for(int i=1; i<=n; i++)
            for(int j=1; j<=n; j++)
                dp[i][j]=dp[i-1][j]+dp[i][j-1]-dp[i-1][j-1]+a[i][j];
    //暴力枚举
        for(int i=n; i>=1; i--)
            for(int j=n; j>=1; j--)
                for(int k=1; k<=i; k++)
                    for(int l=1; l<=j; l++)
                        ans[i][j]=max(ans[i][j],dp[i][j]-dp[i-k][j]-dp[i][j-l]+dp[i-k][j-l]);
    //找最大值
        int an=-12345678;
        for(int i=1; i<=n; i++)
            for(int j=1; j<=n; j++)
                an=max(an,ans[i][j]);
        printf("%d\n",an);
    }
    //fclose(stdin);
    return 0;
}

上面我们是枚举固定(i,j)移动(k,l)的情况,因为只要我们跑完了所有点,这4重循环的位置关系的改变并不影响结果,所以我们可以把四层for循环改成这样:

for(int i=n; i>=1; i--)
    for(int k=1; k<=i; k++)
        for(int j=n; j>=1; j--)
            for(int l=1; l<=j; l++)
                ans[i][j]=max(ans[i][j],dp[i][j]-dp[i-k][j]-dp[i][j-l]+dp[i-k][j-l]);

这里我们是先固定是矩形区域的上下边界,再枚举左右边界。这应该好理解,那么剩下我们该怎么优化呢。

当当我们的k=i+1的时候,我们求的是单排的最大连续矩形的和,可以看作一维数组的最大连续和,我们只需要O(n)的时间复杂度就能扫过去。

当我们要算k=i+2的时候,只需要把这个一位数组的值每项加上相应的列数,再一次O(n)又能求出这些结果。

由于k与i要枚举n^2,所以这种优化的方式时间复杂度是O(n^3)。

#include <iostream>
#include"cstdio"
#include"string.h"
#include"vector"
using namespace std;

const int N = 105;
const int INF = 1<<29;
int a[N][N];
int dp[N];
int sum[N];
int n,m;

int main()
{
    //freopen("in.txt","r",stdin);
    while(scanf("%d",&n)!=EOF)
    {
        memset(a,0,sizeof(a));
        for(int i=1; i<=n; i++)
            for(int j=1; j<=n; j++)
                scanf("%d",&a[i][j]);

        int ans=-INF;
        for(int i=1; i<=n; i++)
        {
        //每次改变上界限都要重置sum数组为0
            memset(sum,0,sizeof(sum));
            for(int j=i; j<=n; j++)
            {
                //下界限每次+1时把新加入的数加到sum数组中去
                for(int k=1;k<=n;k++)
                    sum[k]=sum[k]+a[j][k];
                //dp求解最大连续和,并随时更新ans
                for(int k=1;k<=n;k++)
                {
                     dp[k]=max(sum[k],dp[k-1]+sum[k]);
                     ans=max(ans,dp[k]);
                }
            }
        }
        printf("%d\n",ans);
    }
    return 0;
}

第一种的用时和空间分别为:62MS 1696K

第二种的用时和空间分别为:15MS 1612K

版权声明:本文为博主原创文章,未经博主允许不得转载。

时间: 2024-12-13 02:17:31

HDU 1081 To The Max 暴力模拟O(n^4) dp优化O(n^3)的相关文章

HDU 1081 To The Max(DP)

题意  求一个n*n矩阵的最大子矩阵和 HDU 1003 max sum 的升级版   把二维简化为一维就可以用1003的方法去做了  用mat[i][j]存  第i行前j个数的和   那么mat[k][j]-mat[k][i]就表示第k行  第i+1个数到第j个数的和了   再将k从一枚举到n就可以得到这个这个宽度为j-i的最大矩阵和了   然后i,j又分别从1枚举到n就能得到结果了   和1003的方法一样  只是多了两层循环 #include<cstdio> #include<cs

hdu 1081 To The Max(dp+化二维为一维)

题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=1081 To The Max Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)Total Submission(s): 8839    Accepted Submission(s): 4281 Problem Description Given a two-dimensional ar

HDU 1081 to the max 基础DP 好题

To The Max Problem Description Given a two-dimensional array of positive and negative integers, a sub-rectangle is any contiguous sub-array of size 1 x 1 or greater located within the whole array. The sum of a rectangle is the sum of all the elements

HDU 1081 To The Max

题目链接 Problem Description Given a two-dimensional array of positive and negative integers, a sub-rectangle is any contiguous sub-array of size 1 x 1 or greater located within the whole array. The sum of a rectangle is the sum of all the elements in th

hdu 1081 To The Max 【最大子矩阵和】

To The Max Time Limit: 2000/1000 MS (Java/Others) Memory Limit: 65536/32768 K (Java/Others) Total Submission(s): 8882 Accepted Submission(s): 4288 Problem Description Given a two-dimensional array of positive and negative integers, a sub-rectangle is

HDU 1081 To the Max 最大子矩阵(动态规划求最大连续子序列和)

Description Given a two-dimensional array of positive and negative integers, a sub-rectangle is any contiguous sub-array of size 1*1 or greater located within the whole array. The sum of a rectangle is the sum of all the elements in that rectangle. I

hdu 1081 To The Max(最大连续子序列推广到二维)

#include<cstdio> #include<cstring> #include<algorithm> using namespace std; const int INF=1<<30; int a[105][105]; int b[105]; int dp[105]; int maxx,ans; int main() { int n; while(scanf("%d",&n)==1) { for(int i=1;i<

hdu 4975 最大流问题解决队伍和矩阵,利用矩阵dp优化

//刚開始乱搞. //网络流求解,假设最大流=全部元素的和则有解:利用残留网络推断是否唯一, //方法有两种,第一种是深搜看看是否存在正边权的环.见上一篇4888 //至少四个点构成的环,另外一种是用矩阵dp,仅仅须要满足某行的i列元素<9,j列元素>0,而还有一行的i列元素>0,j列元素<9, //能够满足互补就证明不唯一.这个绘图不难看出 #include<stdio.h> #include<string.h> #include<queue>

hdu 5641 King&#39;s Phone(暴力模拟题)

Problem Description In a military parade, the King sees lots of new things, including an Andriod Phone. He becomes interested in the pattern lock screen. The pattern interface is a 3×3 square lattice, the three points in the first line are labeled as